/* warp.c generated by valac 0.42.3, the Vala compiler
 * generated from warp.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 * Gnome Nibbles: Gnome Worm Game
 * Copyright (C) 2015 Iulian-Gabriel Radu <iulian.radu67@gmail.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/* This is a fairly literal translation of the GPLv2+ original by*/
/* Sean MacIsaac, Ian Peters, Guillaume Béland.*/


#include <glib.h>
#include <glib-object.h>
#include <gee.h>


#define TYPE_WARP (warp_get_type ())
#define WARP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_WARP, Warp))
#define WARP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_WARP, WarpClass))
#define IS_WARP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_WARP))
#define IS_WARP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_WARP))
#define WARP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_WARP, WarpClass))

typedef struct _Warp Warp;
typedef struct _WarpClass WarpClass;
typedef struct _WarpPrivate WarpPrivate;
enum  {
	WARP_0_PROPERTY,
	WARP_NUM_PROPERTIES
};
static GParamSpec* warp_properties[WARP_NUM_PROPERTIES];

#define TYPE_WARP_MANAGER (warp_manager_get_type ())
#define WARP_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_WARP_MANAGER, WarpManager))
#define WARP_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_WARP_MANAGER, WarpManagerClass))
#define IS_WARP_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_WARP_MANAGER))
#define IS_WARP_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_WARP_MANAGER))
#define WARP_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_WARP_MANAGER, WarpManagerClass))

typedef struct _WarpManager WarpManager;
typedef struct _WarpManagerClass WarpManagerClass;
typedef struct _WarpManagerPrivate WarpManagerPrivate;
enum  {
	WARP_MANAGER_0_PROPERTY,
	WARP_MANAGER_NUM_PROPERTIES
};
static GParamSpec* warp_manager_properties[WARP_MANAGER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
enum  {
	WARP_MANAGER_WARP_ADDED_SIGNAL,
	WARP_MANAGER_NUM_SIGNALS
};
static guint warp_manager_signals[WARP_MANAGER_NUM_SIGNALS] = {0};

struct _Warp {
	GObject parent_instance;
	WarpPrivate * priv;
	gint x;
	gint y;
	gint wx;
	gint wy;
};

struct _WarpClass {
	GObjectClass parent_class;
};

struct _WarpManager {
	GObject parent_instance;
	WarpManagerPrivate * priv;
	GeeLinkedList* warps;
};

struct _WarpManagerClass {
	GObjectClass parent_class;
};


static gpointer warp_parent_class = NULL;
static gpointer warp_manager_parent_class = NULL;

GType warp_get_type (void) G_GNUC_CONST;
Warp* warp_new (gint x,
                gint y,
                gint wx,
                gint wy);
Warp* warp_construct (GType object_type,
                      gint x,
                      gint y,
                      gint wx,
                      gint wy);
static void warp_finalize (GObject * obj);
GType warp_manager_get_type (void) G_GNUC_CONST;
#define WARP_MANAGER_MAX_WARPS 200
WarpManager* warp_manager_new (void);
WarpManager* warp_manager_construct (GType object_type);
void warp_manager_add_warp (WarpManager* self,
                            gint* board,
                            int board_length1,
                            int board_length2,
                            gint x,
                            gint y,
                            gint wx,
                            gint wy);
#define NIBBLES_GAME_WARPCHAR 'W'
Warp* warp_manager_get_warp (WarpManager* self,
                             gint x,
                             gint y);
static void warp_manager_finalize (GObject * obj);


Warp*
warp_construct (GType object_type,
                gint x,
                gint y,
                gint wx,
                gint wy)
{
	Warp * self = NULL;
#line 30 "warp.vala"
	self = (Warp*) g_object_new (object_type, NULL);
#line 32 "warp.vala"
	self->x = x;
#line 33 "warp.vala"
	self->y = y;
#line 35 "warp.vala"
	self->wx = wx;
#line 36 "warp.vala"
	self->wy = wy;
#line 30 "warp.vala"
	return self;
#line 146 "warp.c"
}


Warp*
warp_new (gint x,
          gint y,
          gint wx,
          gint wy)
{
#line 30 "warp.vala"
	return warp_construct (TYPE_WARP, x, y, wx, wy);
#line 158 "warp.c"
}


static void
warp_class_init (WarpClass * klass)
{
#line 22 "warp.vala"
	warp_parent_class = g_type_class_peek_parent (klass);
#line 22 "warp.vala"
	G_OBJECT_CLASS (klass)->finalize = warp_finalize;
#line 169 "warp.c"
}


static void
warp_instance_init (Warp * self)
{
}


static void
warp_finalize (GObject * obj)
{
	Warp * self;
#line 22 "warp.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_WARP, Warp);
#line 22 "warp.vala"
	G_OBJECT_CLASS (warp_parent_class)->finalize (obj);
#line 187 "warp.c"
}


GType
warp_get_type (void)
{
	static volatile gsize warp_type_id__volatile = 0;
	if (g_once_init_enter (&warp_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (WarpClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) warp_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Warp), 0, (GInstanceInitFunc) warp_instance_init, NULL };
		GType warp_type_id;
		warp_type_id = g_type_register_static (G_TYPE_OBJECT, "Warp", &g_define_type_info, 0);
		g_once_init_leave (&warp_type_id__volatile, warp_type_id);
	}
	return warp_type_id__volatile;
}


WarpManager*
warp_manager_construct (GType object_type)
{
	WarpManager * self = NULL;
	GeeLinkedList* _tmp0_;
#line 48 "warp.vala"
	self = (WarpManager*) g_object_new (object_type, NULL);
#line 50 "warp.vala"
	_tmp0_ = gee_linked_list_new (TYPE_WARP, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 50 "warp.vala"
	_g_object_unref0 (self->warps);
#line 50 "warp.vala"
	self->warps = _tmp0_;
#line 48 "warp.vala"
	return self;
#line 220 "warp.c"
}


WarpManager*
warp_manager_new (void)
{
#line 48 "warp.vala"
	return warp_manager_construct (TYPE_WARP_MANAGER);
#line 229 "warp.c"
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 59 "warp.vala"
	return self ? g_object_ref (self) : NULL;
#line 238 "warp.c"
}


void
warp_manager_add_warp (WarpManager* self,
                       gint* board,
                       int board_length1,
                       int board_length2,
                       gint x,
                       gint y,
                       gint wx,
                       gint wy)
{
	gboolean add = FALSE;
#line 53 "warp.vala"
	g_return_if_fail (self != NULL);
#line 55 "warp.vala"
	add = TRUE;
#line 57 "warp.vala"
	if (x < 0) {
#line 259 "warp.c"
		GeeLinkedList* _tmp15_;
		gint _tmp16_;
		gint _tmp17_;
		GeeLinkedList* _tmp18_;
		Warp* _tmp19_;
		Warp* _tmp20_;
		{
			GeeLinkedList* _warp_list = NULL;
			GeeLinkedList* _tmp0_;
			GeeLinkedList* _tmp1_;
			gint _warp_size = 0;
			GeeLinkedList* _tmp2_;
			gint _tmp3_;
			gint _tmp4_;
			gint _warp_index = 0;
#line 59 "warp.vala"
			_tmp0_ = self->warps;
#line 59 "warp.vala"
			_tmp1_ = _g_object_ref0 (_tmp0_);
#line 59 "warp.vala"
			_warp_list = _tmp1_;
#line 59 "warp.vala"
			_tmp2_ = _warp_list;
#line 59 "warp.vala"
			_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
#line 59 "warp.vala"
			_tmp4_ = _tmp3_;
#line 59 "warp.vala"
			_warp_size = _tmp4_;
#line 59 "warp.vala"
			_warp_index = -1;
#line 59 "warp.vala"
			while (TRUE) {
#line 293 "warp.c"
				gint _tmp5_;
				gint _tmp6_;
				gint _tmp7_;
				Warp* warp = NULL;
				GeeLinkedList* _tmp8_;
				gint _tmp9_;
				gpointer _tmp10_;
				Warp* _tmp11_;
				gint _tmp12_;
#line 59 "warp.vala"
				_tmp5_ = _warp_index;
#line 59 "warp.vala"
				_warp_index = _tmp5_ + 1;
#line 59 "warp.vala"
				_tmp6_ = _warp_index;
#line 59 "warp.vala"
				_tmp7_ = _warp_size;
#line 59 "warp.vala"
				if (!(_tmp6_ < _tmp7_)) {
#line 59 "warp.vala"
					break;
#line 315 "warp.c"
				}
#line 59 "warp.vala"
				_tmp8_ = _warp_list;
#line 59 "warp.vala"
				_tmp9_ = _warp_index;
#line 59 "warp.vala"
				_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp8_, _tmp9_);
#line 59 "warp.vala"
				warp = (Warp*) _tmp10_;
#line 61 "warp.vala"
				_tmp11_ = warp;
#line 61 "warp.vala"
				_tmp12_ = _tmp11_->wx;
#line 61 "warp.vala"
				if (_tmp12_ == x) {
#line 331 "warp.c"
					Warp* _tmp13_;
					Warp* _tmp14_;
#line 63 "warp.vala"
					_tmp13_ = warp;
#line 63 "warp.vala"
					_tmp13_->wx = wx;
#line 64 "warp.vala"
					_tmp14_ = warp;
#line 64 "warp.vala"
					_tmp14_->wy = wy;
#line 65 "warp.vala"
					_g_object_unref0 (warp);
#line 65 "warp.vala"
					_g_object_unref0 (_warp_list);
#line 65 "warp.vala"
					return;
#line 348 "warp.c"
				}
#line 59 "warp.vala"
				_g_object_unref0 (warp);
#line 352 "warp.c"
			}
#line 59 "warp.vala"
			_g_object_unref0 (_warp_list);
#line 356 "warp.c"
		}
#line 69 "warp.vala"
		_tmp15_ = self->warps;
#line 69 "warp.vala"
		_tmp16_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp15_);
#line 69 "warp.vala"
		_tmp17_ = _tmp16_;
#line 69 "warp.vala"
		if (_tmp17_ == WARP_MANAGER_MAX_WARPS) {
#line 70 "warp.vala"
			return;
#line 368 "warp.c"
		}
#line 72 "warp.vala"
		_tmp18_ = self->warps;
#line 72 "warp.vala"
		_tmp19_ = warp_new (x, y, wx, wy);
#line 72 "warp.vala"
		_tmp20_ = _tmp19_;
#line 72 "warp.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp18_, _tmp20_);
#line 72 "warp.vala"
		_g_object_unref0 (_tmp20_);
#line 380 "warp.c"
	} else {
		gboolean _tmp37_;
		gint _tmp45_;
		gint _tmp46_;
		gint _tmp47_;
		gint _tmp48_;
		{
			GeeLinkedList* _warp_list = NULL;
			GeeLinkedList* _tmp21_;
			GeeLinkedList* _tmp22_;
			gint _warp_size = 0;
			GeeLinkedList* _tmp23_;
			gint _tmp24_;
			gint _tmp25_;
			gint _warp_index = 0;
#line 76 "warp.vala"
			_tmp21_ = self->warps;
#line 76 "warp.vala"
			_tmp22_ = _g_object_ref0 (_tmp21_);
#line 76 "warp.vala"
			_warp_list = _tmp22_;
#line 76 "warp.vala"
			_tmp23_ = _warp_list;
#line 76 "warp.vala"
			_tmp24_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp23_);
#line 76 "warp.vala"
			_tmp25_ = _tmp24_;
#line 76 "warp.vala"
			_warp_size = _tmp25_;
#line 76 "warp.vala"
			_warp_index = -1;
#line 76 "warp.vala"
			while (TRUE) {
#line 414 "warp.c"
				gint _tmp26_;
				gint _tmp27_;
				gint _tmp28_;
				Warp* warp = NULL;
				GeeLinkedList* _tmp29_;
				gint _tmp30_;
				gpointer _tmp31_;
				Warp* _tmp32_;
				gint _tmp33_;
#line 76 "warp.vala"
				_tmp26_ = _warp_index;
#line 76 "warp.vala"
				_warp_index = _tmp26_ + 1;
#line 76 "warp.vala"
				_tmp27_ = _warp_index;
#line 76 "warp.vala"
				_tmp28_ = _warp_size;
#line 76 "warp.vala"
				if (!(_tmp27_ < _tmp28_)) {
#line 76 "warp.vala"
					break;
#line 436 "warp.c"
				}
#line 76 "warp.vala"
				_tmp29_ = _warp_list;
#line 76 "warp.vala"
				_tmp30_ = _warp_index;
#line 76 "warp.vala"
				_tmp31_ = gee_abstract_list_get ((GeeAbstractList*) _tmp29_, _tmp30_);
#line 76 "warp.vala"
				warp = (Warp*) _tmp31_;
#line 78 "warp.vala"
				_tmp32_ = warp;
#line 78 "warp.vala"
				_tmp33_ = _tmp32_->x;
#line 78 "warp.vala"
				if (_tmp33_ == wx) {
#line 452 "warp.c"
					Warp* _tmp34_;
					Warp* _tmp35_;
					Warp* _tmp36_;
#line 80 "warp.vala"
					_tmp34_ = warp;
#line 80 "warp.vala"
					_tmp34_->x = x;
#line 81 "warp.vala"
					_tmp35_ = warp;
#line 81 "warp.vala"
					_tmp35_->y = y;
#line 82 "warp.vala"
					add = FALSE;
#line 84 "warp.vala"
					_tmp36_ = warp;
#line 84 "warp.vala"
					g_signal_emit (self, warp_manager_signals[WARP_MANAGER_WARP_ADDED_SIGNAL], 0, _tmp36_);
#line 470 "warp.c"
				}
#line 76 "warp.vala"
				_g_object_unref0 (warp);
#line 474 "warp.c"
			}
#line 76 "warp.vala"
			_g_object_unref0 (_warp_list);
#line 478 "warp.c"
		}
#line 88 "warp.vala"
		_tmp37_ = add;
#line 88 "warp.vala"
		if (_tmp37_) {
#line 484 "warp.c"
			GeeLinkedList* _tmp38_;
			gint _tmp39_;
			gint _tmp40_;
			Warp* warp = NULL;
			Warp* _tmp41_;
			GeeLinkedList* _tmp42_;
			Warp* _tmp43_;
			Warp* _tmp44_;
#line 90 "warp.vala"
			_tmp38_ = self->warps;
#line 90 "warp.vala"
			_tmp39_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp38_);
#line 90 "warp.vala"
			_tmp40_ = _tmp39_;
#line 90 "warp.vala"
			if (_tmp40_ == WARP_MANAGER_MAX_WARPS) {
#line 91 "warp.vala"
				return;
#line 503 "warp.c"
			}
#line 93 "warp.vala"
			_tmp41_ = warp_new (x, y, wx, wy);
#line 93 "warp.vala"
			warp = _tmp41_;
#line 94 "warp.vala"
			_tmp42_ = self->warps;
#line 94 "warp.vala"
			_tmp43_ = warp;
#line 94 "warp.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp42_, _tmp43_);
#line 96 "warp.vala"
			_tmp44_ = warp;
#line 96 "warp.vala"
			g_signal_emit (self, warp_manager_signals[WARP_MANAGER_WARP_ADDED_SIGNAL], 0, _tmp44_);
#line 88 "warp.vala"
			_g_object_unref0 (warp);
#line 521 "warp.c"
		}
#line 99 "warp.vala"
		board[(x * board_length2) + y] = (gint) NIBBLES_GAME_WARPCHAR;
#line 99 "warp.vala"
		_tmp45_ = board[(x * board_length2) + y];
#line 100 "warp.vala"
		board[((x + 1) * board_length2) + y] = (gint) NIBBLES_GAME_WARPCHAR;
#line 100 "warp.vala"
		_tmp46_ = board[((x + 1) * board_length2) + y];
#line 101 "warp.vala"
		board[(x * board_length2) + (y + 1)] = (gint) NIBBLES_GAME_WARPCHAR;
#line 101 "warp.vala"
		_tmp47_ = board[(x * board_length2) + (y + 1)];
#line 102 "warp.vala"
		board[((x + 1) * board_length2) + (y + 1)] = (gint) NIBBLES_GAME_WARPCHAR;
#line 102 "warp.vala"
		_tmp48_ = board[((x + 1) * board_length2) + (y + 1)];
#line 539 "warp.c"
	}
}


Warp*
warp_manager_get_warp (WarpManager* self,
                       gint x,
                       gint y)
{
	Warp* result = NULL;
#line 106 "warp.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 552 "warp.c"
	{
		GeeLinkedList* _warp_list = NULL;
		GeeLinkedList* _tmp0_;
		GeeLinkedList* _tmp1_;
		gint _warp_size = 0;
		GeeLinkedList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _warp_index = 0;
#line 108 "warp.vala"
		_tmp0_ = self->warps;
#line 108 "warp.vala"
		_tmp1_ = _g_object_ref0 (_tmp0_);
#line 108 "warp.vala"
		_warp_list = _tmp1_;
#line 108 "warp.vala"
		_tmp2_ = _warp_list;
#line 108 "warp.vala"
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
#line 108 "warp.vala"
		_tmp4_ = _tmp3_;
#line 108 "warp.vala"
		_warp_size = _tmp4_;
#line 108 "warp.vala"
		_warp_index = -1;
#line 108 "warp.vala"
		while (TRUE) {
#line 580 "warp.c"
			gint _tmp5_;
			gint _tmp6_;
			gint _tmp7_;
			Warp* warp = NULL;
			GeeLinkedList* _tmp8_;
			gint _tmp9_;
			gpointer _tmp10_;
			gboolean _tmp11_ = FALSE;
			gboolean _tmp12_ = FALSE;
			gboolean _tmp13_ = FALSE;
			gboolean _tmp14_ = FALSE;
			Warp* _tmp15_;
			gint _tmp16_;
#line 108 "warp.vala"
			_tmp5_ = _warp_index;
#line 108 "warp.vala"
			_warp_index = _tmp5_ + 1;
#line 108 "warp.vala"
			_tmp6_ = _warp_index;
#line 108 "warp.vala"
			_tmp7_ = _warp_size;
#line 108 "warp.vala"
			if (!(_tmp6_ < _tmp7_)) {
#line 108 "warp.vala"
				break;
#line 606 "warp.c"
			}
#line 108 "warp.vala"
			_tmp8_ = _warp_list;
#line 108 "warp.vala"
			_tmp9_ = _warp_index;
#line 108 "warp.vala"
			_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp8_, _tmp9_);
#line 108 "warp.vala"
			warp = (Warp*) _tmp10_;
#line 110 "warp.vala"
			_tmp15_ = warp;
#line 110 "warp.vala"
			_tmp16_ = _tmp15_->x;
#line 110 "warp.vala"
			if (x == _tmp16_) {
#line 622 "warp.c"
				Warp* _tmp17_;
				gint _tmp18_;
#line 110 "warp.vala"
				_tmp17_ = warp;
#line 110 "warp.vala"
				_tmp18_ = _tmp17_->y;
#line 110 "warp.vala"
				_tmp14_ = y == _tmp18_;
#line 631 "warp.c"
			} else {
#line 110 "warp.vala"
				_tmp14_ = FALSE;
#line 635 "warp.c"
			}
#line 110 "warp.vala"
			if (_tmp14_) {
#line 110 "warp.vala"
				_tmp13_ = TRUE;
#line 641 "warp.c"
			} else {
				gboolean _tmp19_ = FALSE;
				Warp* _tmp20_;
				gint _tmp21_;
#line 111 "warp.vala"
				_tmp20_ = warp;
#line 111 "warp.vala"
				_tmp21_ = _tmp20_->x;
#line 111 "warp.vala"
				if (x == (_tmp21_ + 1)) {
#line 652 "warp.c"
					Warp* _tmp22_;
					gint _tmp23_;
#line 111 "warp.vala"
					_tmp22_ = warp;
#line 111 "warp.vala"
					_tmp23_ = _tmp22_->y;
#line 111 "warp.vala"
					_tmp19_ = y == _tmp23_;
#line 661 "warp.c"
				} else {
#line 111 "warp.vala"
					_tmp19_ = FALSE;
#line 665 "warp.c"
				}
#line 111 "warp.vala"
				_tmp13_ = _tmp19_;
#line 669 "warp.c"
			}
#line 110 "warp.vala"
			if (_tmp13_) {
#line 110 "warp.vala"
				_tmp12_ = TRUE;
#line 675 "warp.c"
			} else {
				gboolean _tmp24_ = FALSE;
				Warp* _tmp25_;
				gint _tmp26_;
#line 112 "warp.vala"
				_tmp25_ = warp;
#line 112 "warp.vala"
				_tmp26_ = _tmp25_->x;
#line 112 "warp.vala"
				if (x == _tmp26_) {
#line 686 "warp.c"
					Warp* _tmp27_;
					gint _tmp28_;
#line 112 "warp.vala"
					_tmp27_ = warp;
#line 112 "warp.vala"
					_tmp28_ = _tmp27_->y;
#line 112 "warp.vala"
					_tmp24_ = y == (_tmp28_ + 1);
#line 695 "warp.c"
				} else {
#line 112 "warp.vala"
					_tmp24_ = FALSE;
#line 699 "warp.c"
				}
#line 112 "warp.vala"
				_tmp12_ = _tmp24_;
#line 703 "warp.c"
			}
#line 110 "warp.vala"
			if (_tmp12_) {
#line 110 "warp.vala"
				_tmp11_ = TRUE;
#line 709 "warp.c"
			} else {
				gboolean _tmp29_ = FALSE;
				Warp* _tmp30_;
				gint _tmp31_;
#line 113 "warp.vala"
				_tmp30_ = warp;
#line 113 "warp.vala"
				_tmp31_ = _tmp30_->x;
#line 113 "warp.vala"
				if (x == (_tmp31_ + 1)) {
#line 720 "warp.c"
					Warp* _tmp32_;
					gint _tmp33_;
#line 113 "warp.vala"
					_tmp32_ = warp;
#line 113 "warp.vala"
					_tmp33_ = _tmp32_->y;
#line 113 "warp.vala"
					_tmp29_ = y == (_tmp33_ + 1);
#line 729 "warp.c"
				} else {
#line 113 "warp.vala"
					_tmp29_ = FALSE;
#line 733 "warp.c"
				}
#line 113 "warp.vala"
				_tmp11_ = _tmp29_;
#line 737 "warp.c"
			}
#line 110 "warp.vala"
			if (_tmp11_) {
#line 114 "warp.vala"
				result = warp;
#line 114 "warp.vala"
				_g_object_unref0 (_warp_list);
#line 114 "warp.vala"
				return result;
#line 747 "warp.c"
			}
#line 108 "warp.vala"
			_g_object_unref0 (warp);
#line 751 "warp.c"
		}
#line 108 "warp.vala"
		_g_object_unref0 (_warp_list);
#line 755 "warp.c"
	}
#line 117 "warp.vala"
	result = NULL;
#line 117 "warp.vala"
	return result;
#line 761 "warp.c"
}


static void
warp_manager_class_init (WarpManagerClass * klass)
{
#line 40 "warp.vala"
	warp_manager_parent_class = g_type_class_peek_parent (klass);
#line 40 "warp.vala"
	G_OBJECT_CLASS (klass)->finalize = warp_manager_finalize;
#line 40 "warp.vala"
	warp_manager_signals[WARP_MANAGER_WARP_ADDED_SIGNAL] = g_signal_new ("warp-added", TYPE_WARP_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_WARP);
#line 774 "warp.c"
}


static void
warp_manager_instance_init (WarpManager * self)
{
}


static void
warp_manager_finalize (GObject * obj)
{
	WarpManager * self;
#line 40 "warp.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_WARP_MANAGER, WarpManager);
#line 44 "warp.vala"
	_g_object_unref0 (self->warps);
#line 40 "warp.vala"
	G_OBJECT_CLASS (warp_manager_parent_class)->finalize (obj);
#line 794 "warp.c"
}


GType
warp_manager_get_type (void)
{
	static volatile gsize warp_manager_type_id__volatile = 0;
	if (g_once_init_enter (&warp_manager_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (WarpManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) warp_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (WarpManager), 0, (GInstanceInitFunc) warp_manager_instance_init, NULL };
		GType warp_manager_type_id;
		warp_manager_type_id = g_type_register_static (G_TYPE_OBJECT, "WarpManager", &g_define_type_info, 0);
		g_once_init_leave (&warp_manager_type_id__volatile, warp_manager_type_id);
	}
	return warp_manager_type_id__volatile;
}



